<script setup lang="ts">
import { computed, ref } from "vue";
import type { UserOut } from "@/client";
import { useSettingsStore, useUserStore } from "@/stores";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import DeleteModal from "./DeleteModal.vue";

const props = defineProps<{
  modalId: string;
  user: UserOut;
}>();

const confirmDelete = ref<string>("");
const emit = defineEmits<{
  (e: "confirm-delete", uid: string): void;
}>();
const textInputElement = ref<HTMLInputElement | undefined>(undefined);

const userRepository = useUserStore();
const settings = useSettingsStore();

const randomIDSuffix = Math.random().toString(16).substring(2, 8);

function modalClosed() {
  confirmDelete.value = "";
}

function modalShown() {
  textInputElement.value?.focus();
}

function deleteUser() {
  emit("confirm-delete", props.user.uid);
  window._paq?.push(["trackEvent", "Delete", "user"]);
  confirmDelete.value = "";
}

const confirmDeleteString = computed<string>(
  () =>
    props.user.display_name
      .replace(/([a-z])([A-Z])/g, "$1-$2")
      .replace(/[\s_]+/g, "-")
      .toLowerCase() +
    "/" +
    randomIDSuffix,
);

const deleteCurrentUser = computed<boolean>(
  () => props.user.uid === userRepository.currentUID,
);
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    delete-type="Account"
    :disabled="confirmDelete !== confirmDeleteString"
    @confirm-delete="deleteUser"
    v-on="{ 'shown.bs.modal': modalShown, 'hidden.bs.modal': modalClosed }"
  >
    <template #body>
      <div v-if="deleteCurrentUser">
        <div class="text-danger">
          <font-awesome-icon icon="fa-solid fa-circle-exclamation" />
          You are about to delete your account. You won't have access anymore
          to:
        </div>
        <ul>
          <li>Your data buckets and their content</li>
          <li>Your workflow executions and their parameterization</li>
          <li v-if="userRepository.workflowDev">
            Your workflows and their KPIs
          </li>
          <li v-if="userRepository.resourceMaintainer">Your CloWM resources</li>
        </ul>
      </div>
      <div v-else>
        <div class="text-danger">
          <font-awesome-icon icon="fa-solid fa-circle-exclamation" />
          You are about to delete the account of
          <strong>{{ user.display_name }}</strong
          >. You won't be able to log in to CloWM anymore and won't have access
          to his data etc.
        </div>
      </div>
    </template>
    <template #confirmDelete>
      <p>
        Enter the following to confirm: <br /><code
          class="rounded p-1 user-select-none"
          :class="{
            'bg-light': settings.lightThemeActive,
            'text-bg-secondary': !settings.lightThemeActive,
          }"
          >{{ confirmDeleteString }}</code
        >
      </p>
      <div>
        <input
          ref="textInputElement"
          v-model="confirmDelete"
          type="text"
          class="form-control"
        />
      </div>
    </template>
  </delete-modal>
</template>

<style scoped></style>
